OGRE-Next: Ogre::VectorSet< T, S > Struct Template Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::VectorSet< T, S > Struct Template Reference

VectorSet is basically a helper to use a vector as a small set container. More...

`#include <OgreVectorSet.h>`

Inheritance diagram for Ogre::VectorSet< T, S >:
[legend]

## Public Types
typedef SmallVector< T, S >::iterator | iterator
Public Types inherited from Ogre::SmallVectorImpl< T >
typedef SuperClass::iterator | iterator
typedef SuperClass::size_type | size_type
Public Types inherited from Ogre::SmallVectorTemplateCommon< T >
typedef const T * | const_iterator
typedef const T * | const_pointer
typedef const T & | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef ptrdiff_t | difference_type
typedef T * | iterator
typedef T * | pointer
typedef T & | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef size_t | size_type
typedef T | value_type

## Public Member Functions
iterator | add (const T &item)
void | addNotExists (const T &item)
iterator | find (const T &item)
iterator | findExists (const T &item)
bool | has (const T &item)
bool | remove (const T &item)
void | remove (iterator it)
void | removeExists (const T &item)
void | replaceExists (const T &oldItem, const T &newItem)
Public Member Functions inherited from Ogre::SmallVector< T, S >
| SmallVector ()
const SmallVector & | operator= (const SmallVector &RHS)
Public Member Functions inherited from Ogre::SmallVectorImpl< T >
| SmallVectorImpl (unsigned N)
| ~SmallVectorImpl ()
template<typename in_iter>
void | append (in_iter in_start, in_iter in_end)
| append - Add the specified range to the end of the SmallVector.
void | append (size_type NumInputs, const T &Elt)
| append - Add the specified range to the end of the SmallVector.
void | assign (unsigned NumElts, const T &Elt)
void | clear ()
iterator | erase (iterator I)
iterator | erase (iterator S, iterator E)
iterator | insert (iterator I, const T &Elt)
template<typename ItTy>
iterator | insert (iterator I, ItTy From, ItTy To)
iterator | insert (iterator I, size_type NumToInsert, const T &Elt)
bool | operator!= (const SmallVectorImpl &RHS) const
bool | operator< (const SmallVectorImpl &RHS) const
const SmallVectorImpl & | operator= (const SmallVectorImpl &RHS)
bool | operator== (const SmallVectorImpl &RHS) const
void | pop_back ()
T | pop_back_val ()
void | push_back (const T &Elt)
void | reserve (unsigned N)
void | resize (unsigned N)
void | resize (unsigned N, const T &NV)
void | set_size (unsigned N)
| set_size - Set the array size to
void | swap (SmallVectorImpl &RHS)
Public Member Functions inherited from Ogre::SmallVectorTemplateBase< T, isPodLike< T >::value >
| SmallVectorTemplateBase (size_t Size)
void | grow (size_t MinSize=0)
| grow - double the size of the allocated memory, guaranteeing space for at least one more element or MinSize if specified.
Public Member Functions inherited from Ogre::SmallVectorTemplateCommon< T >
| SmallVectorTemplateCommon (size_t Size)
reference | back ()
const_reference | back () const
iterator | begin ()
const_iterator | begin () const
size_t | capacity () const
| capacity - Return the total number of elements in the currently allocated buffer.
pointer | data ()
| data - Return a pointer to the vector's buffer, even if empty().
const_pointer | data () const
| data - Return a pointer to the vector's buffer, even if empty().
iterator | end ()
const_iterator | end () const
reference | front ()
const_reference | front () const
size_type | max_size () const
reference | operator[] (unsigned idx)
const_reference | operator[] (unsigned idx) const
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
reverse_iterator | rend ()
const_reverse_iterator | rend () const
size_type | size () const
Public Member Functions inherited from Ogre::SmallVectorBase
bool | empty () const

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::SmallVectorTemplateBase< T, isPodLike< T >::value >
static void | destroy_range (T *S, T *E)
static void | uninitialized_copy (It1 I, It1 E, It2 Dest)
| uninitialized_copy - Copy the range [I, E) onto the uninitialized memory starting with "Dest", constructing elements into it as needed.

## Detailed Description

template<typename T, unsigned S>
struct Ogre::VectorSet< T, S >

VectorSet is basically a helper to use a vector as a small set container.

Also these functions keep the code clean and fast. You can insert in O(1) time, if you know that it doesn't exists. You can remove in O(1) time, if you know the position of the item.

## Member Typedef Documentation

## ◆ iterator

template<typename T, unsigned S>

typedef SmallVector<T,S>::iterator Ogre::VectorSet< T, S >::iterator

## Member Function Documentation

## ◆ add()

template<typename T, unsigned S>

VectorSet< T, S >::iterator Ogre::VectorSet< T, S >::add | ( | const T & | item | ) |

References Ogre::SmallVectorTemplateCommon< T >::end(), find(), and Ogre::SmallVectorImpl< T >::push_back().

## ◆ addNotExists()

template<typename T, unsigned S>

void Ogre::VectorSet< T, S >::addNotExists | ( | const T & | item | ) |

References Ogre::SmallVectorTemplateCommon< T >::end(), find(), OgreAssert, and Ogre::SmallVectorImpl< T >::push_back().

## ◆ find()

template<typename T, unsigned S>

VectorSet< T, S >::iterator Ogre::VectorSet< T, S >::find | ( | const T & | item | ) |

References Ogre::SmallVectorTemplateCommon< T >::begin(), and Ogre::SmallVectorTemplateCommon< T >::end().

Referenced by add(), addNotExists(), findExists(), has(), remove(), removeExists(), and replaceExists().

## ◆ findExists()

template<typename T, unsigned S>

VectorSet< T, S >::iterator Ogre::VectorSet< T, S >::findExists | ( | const T & | item | ) |

References Ogre::SmallVectorTemplateCommon< T >::end(), find(), and OgreAssert.

## ◆ has()

template<typename T, unsigned S>

bool Ogre::VectorSet< T, S >::has | ( | const T & | item | ) |

References Ogre::SmallVectorTemplateCommon< T >::end(), and find().

## ◆ remove() [1/2]

template<typename T, unsigned S>

bool Ogre::VectorSet< T, S >::remove | ( | const T & | item | ) |

References Ogre::SmallVectorTemplateCommon< T >::end(), find(), and remove().

## ◆ remove() [2/2]

template<typename T, unsigned S>

void Ogre::VectorSet< T, S >::remove | ( | iterator | it | ) |

References Ogre::SmallVectorTemplateCommon< T >::back(), and Ogre::SmallVectorImpl< T >::pop_back().

Referenced by remove(), and removeExists().

## ◆ removeExists()

template<typename T, unsigned S>

void Ogre::VectorSet< T, S >::removeExists | ( | const T & | item | ) |

References Ogre::SmallVectorTemplateCommon< T >::end(), find(), OgreAssert, and remove().

## ◆ replaceExists()

template<typename T, unsigned S>

void Ogre::VectorSet< T, S >::replaceExists | ( | const T & | oldItem,
|  | const T & | newItem )

References Ogre::SmallVectorTemplateCommon< T >::end(), find(), and OgreAssert.

The documentation for this struct was generated from the following files:

- OgreVectorSet.h
- OgreVectorSetImpl.h